Opened 11 years ago

Closed 11 years ago

#22032 closed defect (fixed)

subversion 1.6.5 segfault during commit

Reported by: enolte@… Owned by: danielluke (Daniel J. Luke)
Priority: Normal Milestone:
Component: ports Version: 1.8.1
Keywords: Cc: ryandesign (Ryan Schmidt), jbrownson@…, kena@…, royliu@…, lyle@…, gwynne@…
Port: subversion

Description

The svn client crashes whenever I commit to a local repository.

Mac OS X: 10.6.1 Xcode: 3.2.1 Mac Ports: 1.8.1

Steps to reproduce:

sudo port install subversion
type svn # expect /opt/local/bin/svn
svnadmin create foo
svn checkout file://$PWD/foo bar
cd bar
touch x
svn add x
svn commit -m "time to die"

Attachments (2)

error.txt (13.3 KB) - added by enolte@… 11 years ago.
Problem report for svn
configure.patch (548 bytes) - added by gwynne@… 11 years ago.
Quick patch to make things work again.

Download all attachments as: .zip

Change History (37)

Changed 11 years ago by enolte@…

Attachment: error.txt added

Problem report for svn

comment:1 Changed 11 years ago by danielluke (Daniel J. Luke)

Works for me:

[xeon:~/test-svn] dluke% sw_vers
ProductName:	Mac OS X
ProductVersion:	10.6.1
BuildVersion:	10B504
[xeon:~/test-svn] dluke% svnadmin create foo
[xeon:~/test-svn] dluke% svn checkout file://$PWD/foo bar
Checked out revision 0.
[xeon:~/test-svn] dluke% cd bar
[xeon:~/test-svn/bar] dluke% touch x
[xeon:~/test-svn/bar] dluke% svn add x
A         x
[xeon:~/test-svn/bar] dluke% svn commit -m "time to die"
Adding         x
Transmitting file data .
Committed revision 1.
[xeon:~/test-svn/bar] dluke% 

Did you install a universal build of subversion (and apr?)

You may also want to report this upstream (as it's possibly not a macports bug, but a bug in subversion itself).

comment:2 Changed 11 years ago by danielluke (Daniel J. Luke)

Owner: changed from macports-tickets@… to dluke@…
Status: newassigned

comment:3 in reply to:  1 Changed 11 years ago by danielluke (Daniel J. Luke)

Replying to dluke@…:

Works for me:

[xeon:~/test-svn] dluke% sw_vers
ProductName:	Mac OS X
ProductVersion:	10.6.1
BuildVersion:	10B504
[xeon:~/test-svn] dluke% svnadmin create foo
[xeon:~/test-svn] dluke% svn checkout file://$PWD/foo bar
Checked out revision 0.
[xeon:~/test-svn] dluke% cd bar
[xeon:~/test-svn/bar] dluke% touch x
[xeon:~/test-svn/bar] dluke% svn add x
A         x
[xeon:~/test-svn/bar] dluke% svn commit -m "time to die"
Adding         x
Transmitting file data .
Committed revision 1.
[xeon:~/test-svn/bar] dluke% 

comment:4 Changed 11 years ago by enolte@…

Interesting. I get the segfault every time.

~ 616> file /opt/local/bin/svn
/opt/local/bin/svn: Mach-O 64-bit executable x86_64

~/tmp/bar 622> /opt/local/bin/svn commit
Segmentation fault

~/tmp/bar 627> sw_vers
ProductName:	Mac OS X
ProductVersion:	10.6.1
BuildVersion:	10B504

Are you using the port svn in /opt/local/bin or the Apple svn in /usr/bin? The Apple version always works and the ports version always fails on my machine.

comment:5 Changed 11 years ago by danielluke (Daniel J. Luke)

Did you install fresh versions of subversion and apr on your 10.6 system (ie, nothing is there from a macports install on a 10.5 or 10.4 system?)

The crash is happening inside of apr, so maybe your apr install is not right?

I would try uninstalling/rebuilding apr and then subversion and see if that helps.

comment:6 Changed 11 years ago by enolte@…

I've done multiple fresh macports installs by uninstalling all ports and removing the files and directories mentioned in the FAQ. I then reinstalled the macport pkg and reinstalled just svn and its dependencies to minimize conflicting ports. I also tried limiting the build_arch to i386 to see if it was a 32-bit vs 64-bit problem.

Uninstall/rebuild didn't seem to help:

~/spark/trunk 633> port installed | grep apr
  apr @1.3.9_0 (active)
  apr-util @1.3.9_0 (active)
~/spark/trunk 634> sudo port uninstall -f apr
Password:
--->  Unable to uninstall apr 1.3.9_0, the following ports depend on it:
--->  	apr-util
--->  	serf
Warning: Uninstall forced.  Proceeding despite dependencies.
--->  Deactivating apr @1.3.9_0
--->  Uninstalling apr @1.3.9_0
~/spark/trunk 635> sudo port uninstall -f subversion
~/spark/trunk 636> sudo port clean --all apr subversion
--->  Cleaning apr
--->  Cleaning subversion
~/spark/trunk 638> sudo port install apr subversion
--->  Computing dependencies for apr
--->  Fetching apr
--->  Attempting to fetch apr-1.3.9.tar.bz2 from http://distfiles.macports.org/apr
--->  Verifying checksum(s) for apr
--->  Extracting apr
--->  Configuring apr
--->  Building apr
--->  Staging apr into destroot
--->  Installing apr @1.3.9_0
--->  Activating apr @1.3.9_0
--->  Cleaning apr
--->  Computing dependencies for subversion
--->  Fetching subversion
--->  Attempting to fetch subversion-1.6.5.tar.bz2 from http://subversion.tigris.org/downloads/
--->  Verifying checksum(s) for subversion
--->  Extracting subversion
--->  Applying patches to subversion
--->  Configuring subversion
--->  Building subversion
--->  Staging subversion into destroot
--->  Installing subversion @1.6.5_0
--->  Activating subversion @1.6.5_0
--->  Cleaning subversion
~/tmp/bar 650> /opt/local/bin/svn commit -m "test"
Segmentation fault

comment:7 Changed 11 years ago by danielluke (Daniel J. Luke)

Do you have anything in /usr/local that subversion may have linked against? (you can run otool -L /opt/local/bin/svn to see which libraries your svn binary is linked to)

comment:8 Changed 11 years ago by enolte@…

Just /usr/lib/libSystem.B.dylib and /usr/lib/libresolv.9.dylib

~/tmp/bar 651> otool -L /opt/local/bin/svn
/opt/local/bin/svn:
	/System/Library/Frameworks/Security.framework/Versions/A/Security (compatibility version 1.0.0, current version 36910.0.0)
	/System/Library/Frameworks/CoreServices.framework/Versions/A/CoreServices (compatibility version 1.0.0, current version 44.0.0)
	/opt/local/lib/libsvn_client-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_wc-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_ra-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_diff-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_ra_local-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_repos-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_fs-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_fs_fs-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_fs_base-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_fs_util-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_ra_svn-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsasl2.2.dylib (compatibility version 0.0.0, current version 0.0.0)
	/usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current version 124.1.1)
	/opt/local/lib/libsvn_ra_neon-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_ra_serf-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libserf-0.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_delta-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsvn_subr-1.0.dylib (compatibility version 1.0.0, current version 1.0.0)
	/opt/local/lib/libsqlite3.0.dylib (compatibility version 9.0.0, current version 9.6.0)
	/opt/local/lib/libaprutil-1.0.dylib (compatibility version 4.0.0, current version 4.9.0)
	/opt/local/lib/db46/libdb-4.6.dylib (compatibility version 0.0.0, current version 0.0.0)
	/opt/local/lib/libapr-1.0.dylib (compatibility version 4.0.0, current version 4.9.0)
	/opt/local/lib/libneon.27.dylib (compatibility version 29.0.0, current version 29.6.0)
	/opt/local/lib/libssl.0.9.8.dylib (compatibility version 0.9.8, current version 0.9.8)
	/opt/local/lib/libcrypto.0.9.8.dylib (compatibility version 0.9.8, current version 0.9.8)
	/opt/local/lib/libz.1.dylib (compatibility version 1.0.0, current version 1.2.3)
	/System/Library/Frameworks/Kerberos.framework/Versions/A/Kerberos (compatibility version 5.0.0, current version 5.0.0)
	/usr/lib/libresolv.9.dylib (compatibility version 1.0.0, current version 38.0.0)
	/opt/local/lib/libexpat.1.dylib (compatibility version 7.0.0, current version 7.2.0)
	/opt/local/lib/libintl.8.dylib (compatibility version 9.0.0, current version 9.2.0)
	/opt/local/lib/libiconv.2.dylib (compatibility version 8.0.0, current version 8.0.0)

comment:9 Changed 11 years ago by danielluke (Daniel J. Luke)

... and you don't have any DYLD_* variables set in your environment? (printenv)

comment:10 Changed 11 years ago by enolte@…

Nope

~/tmp/bar 655> printenv |sort
ANT_ARGS=-find build.xml -emacs
ANT_HOME=
ANT_OPTS=-ea
Apple_PubSub_Socket_Render=/tmp/launch-CADyIY/Render
COMMAND_MODE=unix2003
CVSROOT=:pserver:enolte@cvs.tigris.org:/cvs
DISPLAY=/tmp/launch-swRsyt/:0
EDITOR=vim
FIGNORE=.DS_Store:CVS:.svn:.bzr
HOME=/Users/enolte
LANG=en_US.UTF-8
LOGNAME=enolte
LSCOLORS=exfxcxcxdxcxcxbxbxexex
OLDPWD=/Users/enolte/tmp
PATH=/Users/enolte/installer/bin:/Users/enolte/bin:/opt/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11/bin
PS1=$PS1PWD \!> 
PWD=/Users/enolte/tmp/bar
PYTHONSTARTUP=/Users/enolte/.python
SECURITYSESSIONID=240cf7
SHELL=/bin/bash
SHLVL=1
SSH_AUTH_SOCK=/tmp/launch-X07ZLx/Listeners
TERM=xterm-color
TERM_PROGRAM=Apple_Terminal
TERM_PROGRAM_VERSION=272
TMPDIR=/var/folders/+s/+sydFbBtGlSZNyxtBs5-bk+++TI/-Tmp-/
USER=enolte
_=/usr/bin/printenv
__CF_USER_TEXT_ENCODING=0x1F5:0:0

comment:11 Changed 11 years ago by danielluke (Daniel J. Luke)

One more thought, can you try without LANG set?

comment:12 Changed 11 years ago by enolte@…

The segfault persists with LANG unset as well as most other env vars. Are there any system libraries or config files I should look at? e.g. does the dynamic linker look at anything in /etc or /lib and implicitly add it to my environment or LD_LIBRARY_PATH?

~/tmp/bar 663> unset LANG
~/tmp/bar 664> printenv | sort
ANT_ARGS=-find build.xml -emacs
ANT_HOME=
ANT_OPTS=-ea
Apple_PubSub_Socket_Render=/tmp/launch-CADyIY/Render
COMMAND_MODE=unix2003
CVSROOT=:pserver:enolte@cvs.tigris.org:/cvs
DISPLAY=/tmp/launch-swRsyt/:0
EDITOR=vim
FIGNORE=.DS_Store:CVS:.svn:.bzr
HOME=/Users/enolte
LOGNAME=enolte
LSCOLORS=exfxcxcxdxcxcxbxbxexex
OLDPWD=/Users/enolte/tmp
PATH=/Users/enolte/installer/bin:/Users/enolte/bin:/opt/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11/bin
PS1=$PS1PWD \!> 
PWD=/Users/enolte/tmp/bar
PYTHONSTARTUP=/Users/enolte/.python
SECURITYSESSIONID=240cf7
SHELL=/bin/bash
SHLVL=1
SSH_AUTH_SOCK=/tmp/launch-X07ZLx/Listeners
TERM=xterm-color
TERM_PROGRAM=Apple_Terminal
TERM_PROGRAM_VERSION=272
TMPDIR=/var/folders/+s/+sydFbBtGlSZNyxtBs5-bk+++TI/-Tmp-/
USER=enolte
_=/usr/bin/printenv
__CF_USER_TEXT_ENCODING=0x1F5:0:0

~/tmp/bar 665> svn cleanup
~/tmp/bar 666> svn commit -m "XXX"
Segmentation fault

~/tmp/bar 667> unset ANT_ARGS ANT_HOME ANT_OPTS Apple_PubSub_Socket_Render COMMAND_MODE CVSROOT DISPLAY EDITOR FIGNORE HOME LSCOLORS OLDPWD PATH PS1 PYTHONSTARTUP SECURITYSESSIONID SSH_AUTH_SOCK TERM TERM_PROGRAM TERM_PROGRAM_VERSION TMPDIR USER __CF_USER_TEXT_ENCODING

/opt/local/bin/svn cleanup
/opt/local/bin/svn commit -m "XXX" 
Segmentation fault

/usr/bin/printenv | /usr/bin/sort
LOGNAME=enolte
PWD=/Users/enolte/tmp/bar
SHELL=/bin/bash
SHLVL=1
_=/usr/bin/printenv

comment:13 in reply to:  12 Changed 11 years ago by danielluke (Daniel J. Luke)

Replying to enolte@…:

The segfault persists with LANG unset as well as most other env vars. Are there any system libraries or config files I should look at? e.g. does the dynamic linker look at anything in /etc or /lib and implicitly add it to my environment or LD_LIBRARY_PATH?

Not that I know of.

I don't know what else would be different in your system that would cause this...

You might have more luck asking on the subversion users mailing list.

comment:14 in reply to:  12 Changed 11 years ago by blb@…

Replying to enolte@…:

The segfault persists with LANG unset as well as most other env vars. Are there any system libraries or config files I should look at? e.g. does the dynamic linker look at anything in /etc or /lib and implicitly add it to my environment or LD_LIBRARY_PATH?

It'll use the libraries from the hardcoded paths you see with otool -L unless you have a DYLD-based env var set, which you don't...

Anything else interesting about your system like case-sensitive file system, or not HFS+ at all? I just tried commits with setting several various bits in your env that aren't normally in mine, no seg faults, so I don't think there's anything there.

comment:15 Changed 11 years ago by enolte@…

Yes, I'm running a case-sensitive HFS+ file system.

comment:16 Changed 11 years ago by blb@…

Looks like a case-sensitivity issue, svn works fine for me on HFS+ but I see the same segfault on HFS+ case-sensitive; note that svn has to be installed on that case-sensitive FS, not just using it for the repo or checkout.

comment:17 Changed 11 years ago by danielluke (Daniel J. Luke)

That's really interesting... and certainly something that needs to be reported upstream.

comment:18 Changed 11 years ago by danielluke (Daniel J. Luke)

If someone who has reproduced this reports it upstream, noting the upstream bug id/url would be helpful (if a patch gets accepted there, I'll add it to the port and we'll can get the fix before the next subversion release).

comment:19 Changed 11 years ago by ryandesign (Ryan Schmidt)

Cc: ryandesign@… added

Cc Me!

comment:20 Changed 11 years ago by r1pp3r@…

Cc: r1pp3r@… added

Cc Me!

comment:21 Changed 11 years ago by r1pp3r@…

Cc: r1pp3r@… removed

Cc Me!

comment:22 Changed 11 years ago by jbrownson@…

Cc: jbrownson@… added

Cc Me!

comment:23 in reply to:  16 Changed 11 years ago by jbrownson@…

I'm experiencing the same behavior on a case sensitive fs, might try it on an insensitive later, watching for a resolution

comment:24 Changed 11 years ago by gnicolas@…

I can reproduce on a case insensitive file system (Mac OS Extended Journaled):

$ sw_vers 
ProductName:	Mac OS X
ProductVersion:	10.6.2
BuildVersion:	10C540

Works fine with the built-in svn client:

$ /opt/local/bin/svn --version
svn, version 1.6.5 (r38866)
   compiled Dec 26 2009, 22:41:38

Copyright (C) 2000-2009 CollabNet.
Subversion is open source software, see http://subversion.tigris.org/
This product includes software developed by CollabNet (http://www.Collab.Net/).

The following repository access (RA) modules are available:

* ra_neon : Module for accessing a repository via WebDAV protocol using Neon.
  - handles 'http' scheme
  - handles 'https' scheme
* ra_svn : Module for accessing a repository using the svn network protocol.
  - with Cyrus SASL authentication
  - handles 'svn' scheme
* ra_local : Module for accessing a repository on local disk.
  - handles 'file' scheme
* ra_serf : Module for accessing a repository via WebDAV protocol using serf.
  - handles 'http' scheme
  - handles 'https' scheme

$ /usr/bin/svn --version
svn, version 1.6.5 (r38866)
   compiled Oct 16 2009, 02:54:10

Copyright (C) 2000-2009 CollabNet.
Subversion is open source software, see http://subversion.tigris.org/
This product includes software developed by CollabNet (http://www.Collab.Net/).

The following repository access (RA) modules are available:

* ra_neon : Module for accessing a repository via WebDAV protocol using Neon.
  - handles 'http' scheme
  - handles 'https' scheme
* ra_svn : Module for accessing a repository using the svn network protocol.
  - handles 'svn' scheme
* ra_local : Module for accessing a repository on local disk.
  - handles 'file' scheme

comment:25 Changed 11 years ago by kena@…

Cc: kena@… added

Cc Me!

comment:26 Changed 11 years ago by kena@…

I can reproduce in the same configuration as the previous poster:

$ sw_vers
ProductName:    Mac OS X
ProductVersion: 10.6.2
BuildVersion:   10C540

The issue seems not to be in the Subversion client itself, as the same crash occurs when using git-svn dcommit. The crash also only happens when using a local filesystem repository.

Here is the crash log, which highlights a problem in either svn_fs_fs or apr:

Process:         perl [67247]
Path:            /opt/local/bin/perl
Identifier:      perl
Version:         ??? (???)
Code Type:       X86-64 (Native)
Parent Process:  git [67245]

Date/Time:       2009-12-26 13:17:43.815 +0100
OS Version:      Mac OS X 10.6.2 (10C540)
Report Version:  6

Interval Since Last Report:          920298 sec
Crashes Since Last Report:           17
Per-App Crashes Since Last Report:   6
Anonymous UUID:                      C8D224B1-A18B-4A11-8607-AB391627FB59

Exception Type:  EXC_BAD_ACCESS (SIGSEGV)
Exception Codes: KERN_INVALID_ADDRESS at 0x0000000000000020
Crashed Thread:  0  Dispatch queue: com.apple.main-thread

Thread 0 Crashed:  Dispatch queue: com.apple.main-thread
0   libSystem.B.dylib             	0x00007fff84cfecc0 strlen + 16
1   libapr-1.0.dylib              	0x00000001001a0594 apr_vformatter + 6068
2   libapr-1.0.dylib              	0x00000001001aa43c apr_pvsprintf + 108
3   libapr-1.0.dylib              	0x00000001001aa6db apr_psprintf + 155
4   libsvn_fs_fs-1.0.dylib        	0x000000010126a181 representation_string + 225
5   libsvn_fs_fs-1.0.dylib        	0x000000010126a29b svn_fs_fs__write_noderev + 267
6   libsvn_fs_fs-1.0.dylib        	0x000000010126c545 svn_fs_fs__put_node_revision + 261
7   libsvn_fs_fs-1.0.dylib        	0x000000010126f651 svn_fs_fs__create_txn + 1329
8   libsvn_fs_fs-1.0.dylib        	0x000000010126f772 svn_fs_fs__begin_txn + 130
9   libsvn_repos-1.0.dylib        	0x0000000101107c56 svn_repos_fs_begin_txn_for_commit2 + 150
10  libsvn_repos-1.0.dylib        	0x000000010110280a open_root + 138
11  _Delta.bundle                 	0x00000001017b7741 _wrap_svn_delta_editor_invoke_open_root + 305
12  perl                          	0x0000000100073bdc Perl_pp_entersub + 828
13  perl                          	0x000000010006c126 Perl_runops_standard + 22
14  perl                          	0x000000010006886a perl_run + 730
15  perl                          	0x00000001000014ec main + 204
16  perl                          	0x0000000100001414 start + 52

Thread 0 crashed with X86 Thread State (64-bit):
  rax: 0x00000000ffffffff  rbx: 0x000000010019f124  rcx: 0x0000000000000026  rdx: 0x0000000000000026
  rdi: 0x0000000000000020  rsi: 0x00007fff5fbfe56e  rbp: 0x00007fff5fbfe610  rsp: 0x00007fff5fbfe238
   r8: 0x0000000000000000   r9: 0x00007fff5fbfe690  r10: 0x0000000000000002  r11: 0x0000000000000000
  r12: 0x0000000100d78b1f  r13: 0x000000010127bb8a  r14: 0x0000000000000026  r15: 0x0000000000000000
  rip: 0x00007fff84cfecc0  rfl: 0x0000000000010286  cr2: 0x0000000000000020

Binary Images:
       0x100000000 -        0x10011afff +perl ??? (???) <CEE2F5F0-616D-C674-6E6F-29F745C199DE> /opt/local/bin/perl
       0x10013e000 -        0x100142fff  libutil.dylib ??? (???) <59C14CE0-3608-D246-542A-283E9065261D> /usr/lib/libutil.dylib
       0x100165000 -        0x100167ff7 +MD5.bundle ??? (???) <A06E3C36-E08E-B349-D5C1-9E8199373581> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/Digest/MD5/MD5.bundle
       0x10016a000 -        0x10016cfff +IO.bundle ??? (???) <6964B12C-0567-4267-09EC-16645B0D901E> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/IO/IO.bundle
       0x10016f000 -        0x100171fff +Fcntl.bundle ??? (???) <DBF9F901-F7C1-9584-0CC4-86DC7496E57B> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/Fcntl/Fcntl.bundle
       0x100174000 -        0x100175fff +Cwd.bundle ??? (???) <26A10B96-B664-7C61-64D0-CFF77CA0B0A0> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/Cwd/Cwd.bundle
       0x100178000 -        0x10017bfff +Util.bundle ??? (???) <CB8FF272-B6B5-4F15-FFEB-8E2392E9C592> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/List/Util/Util.bundle
       0x10017e000 -        0x100192fff +POSIX.bundle ??? (???) <A2C402CB-B634-F1E0-4F04-757B02F3EFED> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/POSIX/POSIX.bundle
       0x100198000 -        0x10019afff +Glob.bundle ??? (???) <5F9FBFDD-3612-A10D-EEA9-407F48FA3A2E> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/File/Glob/Glob.bundle
       0x10019d000 -        0x1001bdfff +libapr-1.0.dylib ??? (???) <5B785A1F-4252-E7B2-0598-8D8AA2E044B7> /opt/local/lib/libapr-1.0.dylib
       0x1001c9000 -        0x1001d2fff +libsvn_delta-1.0.dylib ??? (???) <1F4E0A3C-4B7F-FD01-2684-458668DCE220> /opt/local/lib/libsvn_delta-1.0.dylib
       0x1001d7000 -        0x1001dbff7 +libsvn_fs-1.0.dylib ??? (???) <C99F120B-2A65-9CB7-57D5-5CE5BCC09183> /opt/local/lib/libsvn_fs-1.0.dylib
       0x1001e0000 -        0x1001e6fff +libsvn_ra-1.0.dylib ??? (???) <E0C602DF-A586-3F03-94EE-33C16093CC55> /opt/local/lib/libsvn_ra-1.0.dylib
       0x1001eb000 -        0x1001f3fff +libsvn_diff-1.0.dylib ??? (???) <B4E42855-2EF8-CB38-1B04-6F2F20DB1FC2> /opt/local/lib/libsvn_diff-1.0.dylib
       0x1001f7000 -        0x1001fbfff +libsvn_ra_local-1.0.dylib ??? (???) <0CB99698-8746-CB15-1791-7BE87C4539B4> /opt/local/lib/libsvn_ra_local-1.0.dylib
       0x100700000 -        0x100786fff +_Core.bundle ??? (???) <F2B063CC-5FE8-86E2-0BA4-1A12B57FD461> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/SVN/_Core/_Core.bundle
       0x1007b4000 -        0x1007ecfff +libsvn_client-1.0.dylib ??? (???) <0BACCBFD-F7FC-FC3D-5B5E-F018BE0434D5> /opt/local/lib/libsvn_client-1.0.dylib
       0x1007fa000 -        0x1007fafff +libsvn_fs_util-1.0.dylib ??? (???) <BA238000-7F81-A1C0-02DF-44A2F3A9638E> /opt/local/lib/libsvn_fs_util-1.0.dylib
       0x101100000 -        0x101121ff7 +libsvn_repos-1.0.dylib ??? (???) <DA36B4BC-7999-CC5C-48BA-B025D36A53A7> /opt/local/lib/libsvn_repos-1.0.dylib
       0x10112a000 -        0x101164fff +libsvn_wc-1.0.dylib ??? (???) <1FFFE4CA-7C70-80C5-F3C3-22154DC5CA15> /opt/local/lib/libsvn_wc-1.0.dylib
       0x101171000 -        0x1011b0ff7 +libsvn_subr-1.0.dylib ??? (???) <8382C24C-1BDC-D44E-5F33-E491B834AC20> /opt/local/lib/libsvn_subr-1.0.dylib
       0x1011c3000 -        0x1011c8fff +libsvn_swig_perl-1.0.dylib ??? (???) <675C384D-8136-F49C-C3D0-191DB274C64E> /opt/local/lib/libsvn_swig_perl-1.0.dylib
       0x1011cd000 -        0x1011dffe7 +libz.1.dylib ??? (???) <38470C78-F4F9-8278-23E6-5C9B35FE48F1> /opt/local/lib/libz.1.dylib
       0x1011e3000 -        0x101253fef +libsqlite3.0.dylib ??? (???) <BD2456B5-A280-DFD0-41CF-648E7B3C6004> /opt/local/lib/libsqlite3.0.dylib
       0x101263000 -        0x101281fff +libsvn_fs_fs-1.0.dylib ??? (???) <284DEDBE-05F8-9236-F0DD-34474E087CA1> /opt/local/lib/libsvn_fs_fs-1.0.dylib
       0x10128a000 -        0x1012affff +libsvn_fs_base-1.0.dylib ??? (???) <789297FD-B851-8DB3-B756-8A783ED7B8F6> /opt/local/lib/libsvn_fs_base-1.0.dylib
       0x1012b9000 -        0x1012caff7 +libsvn_ra_svn-1.0.dylib ??? (???) <DF5AE25A-5074-5FBF-B08F-A6F1C0017975> /opt/local/lib/libsvn_ra_svn-1.0.dylib
       0x1012d1000 -        0x1012e6fe7 +libsasl2.2.dylib ??? (???) <8A438EA7-F03D-0F9A-E9C1-591CBB2BCE40> /opt/local/lib/libsasl2.2.dylib
       0x1012ec000 -        0x101305fff +libsvn_ra_neon-1.0.dylib ??? (???) <24BED4C6-6155-B9C2-EFAD-B3A0D5D6DDBE> /opt/local/lib/libsvn_ra_neon-1.0.dylib
       0x10130f000 -        0x10132bfff +libneon.27.dylib ??? (???) <1249B49F-24E9-A5AD-8328-C5037579805E> /opt/local/lib/libneon.27.dylib
       0x101335000 -        0x101350ff7 +libsvn_ra_serf-1.0.dylib ??? (???) <B6CF7792-3911-4E67-600A-1C7A97B7F681> /opt/local/lib/libsvn_ra_serf-1.0.dylib
       0x101359000 -        0x101363fff +libserf-0.0.dylib ??? (???) <D3B49DA5-C5B4-D0D8-C01E-F78109E1B336> /opt/local/lib/libserf-0.0.dylib
       0x10136a000 -        0x1013a9fff +libssl.0.9.8.dylib ??? (???) <4E8F5D81-1DFF-5CBD-361A-C37609B799A8> /opt/local/lib/libssl.0.9.8.dylib
       0x1013bd000 -        0x1014d1fe7 +libcrypto.0.9.8.dylib ??? (???) <8848EC7B-6BBC-ED7C-5BFC-16E613D8AE67> /opt/local/lib/libcrypto.0.9.8.dylib
       0x101535000 -        0x10154dff7 +libaprutil-1.0.dylib ??? (???) <5C9118DC-DD38-2F29-EFE1-B41414AAD34A> /opt/local/lib/libaprutil-1.0.dylib
       0x101557000 -        0x101658fef +libdb-4.6.dylib ??? (???) <9C1BB789-60C6-0A5C-5109-A2EF763D135A> /opt/local/lib/db46/libdb-4.6.dylib
       0x10166f000 -        0x10168efff +libexpat.1.dylib ??? (???) <F5454E8D-F66C-640F-9D36-B736F04883E3> /opt/local/lib/libexpat.1.dylib
       0x101695000 -        0x101791ff7 +libiconv.2.dylib ??? (???) <D8818BCE-3F31-4B97-4D60-59A73F478B06> /opt/local/lib/libiconv.2.dylib
       0x10179e000 -        0x1017a6fef +libintl.8.dylib ??? (???) <BE50A520-EDE8-6527-FBB9-FD5CE4DCFFC7> /opt/local/lib/libintl.8.dylib
       0x1017ab000 -        0x1017c6fff +_Delta.bundle ??? (???) <E6E8FF3C-238C-4005-F54E-40CC3B473833> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/SVN/_Delta/_Delta.bundle
       0x1017d7000 -        0x1017f4fe7 +Zlib.bundle ??? (???) <E2AAE31B-25E5-3CC1-06BA-409A01320201> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/Compress/Raw/Zlib/Zlib.bundle
       0x101900000 -        0x10193dff7 +_Ra.bundle ??? (???) <95B70E6B-B6BC-4B97-1CE9-FA3BF0D05C17> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/SVN/_Ra/_Ra.bundle
       0x10195a000 -        0x1019e7fff +_Wc.bundle ??? (???) <534D7955-1BDB-4603-8607-657E20C5B326> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/SVN/_Wc/_Wc.bundle
       0x101a13000 -        0x101a7efff +_Client.bundle ??? (???) <10D35931-782F-6662-F1A3-A168BAC41C8A> /opt/local/lib/perl5/vendor_perl/5.8.9/darwin-2level/auto/SVN/_Client/_Client.bundle
       0x101aa1000 -        0x101aa6fff +Encode.bundle ??? (???) <86611486-A83F-2196-1B48-01A2161921BB> /opt/local/lib/perl5/5.8.9/darwin-2level/auto/Encode/Encode.bundle
    0x7fff5fc00000 -     0x7fff5fc3bdef  dyld 132.1 (???) <B633F790-4DDB-53CD-7ACF-2A3682BCEA9F> /usr/lib/dyld
    0x7fff8018c000 -     0x7fff8019bfff  com.apple.NetFS 3.2.1 (3.2.1) <FF21DB1E-F425-1005-FB70-BC19CAF4006E> /System/Library/Frameworks/NetFS.framework/Versions/A/NetFS
    0x7fff80251000 -     0x7fff802aefef  com.apple.framework.IOKit 2.0 (???) <EBBEED67-D5BE-5F7F-96F4-9023BBA1B913> /System/Library/Frameworks/IOKit.framework/Versions/A/IOKit
    0x7fff802b5000 -     0x7fff802b9ff7  libmathCommon.A.dylib ??? (???) <95718673-FEEE-B6ED-B127-BCDBDB60D4E5> /usr/lib/system/libmathCommon.A.dylib
    0x7fff80365000 -     0x7fff803f5fff  com.apple.SearchKit 1.3.0 (1.3.0) <4175DC31-1506-228A-08FD-C704AC9DF642> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SearchKit.framework/Versions/A/SearchKit
    0x7fff814b0000 -     0x7fff8166efff  libicucore.A.dylib ??? (???) <5BD16988-545F-6A8C-9A6F-FB18ACDCAEC2> /usr/lib/libicucore.A.dylib
    0x7fff8191d000 -     0x7fff8195eff7  com.apple.SystemConfiguration 1.10.1 (1.10.1) <FFCA91A7-ADDB-E3D0-234A-47609BC37556> /System/Library/Frameworks/SystemConfiguration.framework/Versions/A/SystemConfiguration
    0x7fff81b2f000 -     0x7fff81db4ff7  com.apple.security 6.0 (36910) <67DF686D-B991-D0D6-20B6-9EA668018466> /System/Library/Frameworks/Security.framework/Versions/A/Security
    0x7fff8241a000 -     0x7fff82430fef  libbsm.0.dylib ??? (???) <42D3023A-A1F7-4121-6417-FCC6B51B3E90> /usr/lib/libbsm.0.dylib
    0x7fff824f7000 -     0x7fff82518fff  libresolv.9.dylib ??? (???) <01C7C750-7F6A-89B3-C586-5C50A839019E> /usr/lib/libresolv.9.dylib
    0x7fff8273d000 -     0x7fff827f6fff  libsqlite3.dylib ??? (???) <5A15E12A-AE8F-1A36-BBC7-564E7D7AD0FB> /usr/lib/libsqlite3.dylib
    0x7fff83343000 -     0x7fff83354fef  libz.1.dylib ??? (???) <3A7A4C48-A4C8-A78A-8B87-C0DDF6601AC8> /usr/lib/libz.1.dylib
    0x7fff83673000 -     0x7fff8369bfff  com.apple.DictionaryServices 1.1.1 (1.1.1) <9FD709FC-23F0-F270-EAC1-C590CD516A36> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/DictionaryServices.framework/Versions/A/DictionaryServices
    0x7fff8369c000 -     0x7fff83719fef  libstdc++.6.dylib ??? (???) <35ECA411-2C08-FD7D-11B1-1B7A04921A5C> /usr/lib/libstdc++.6.dylib
    0x7fff8376a000 -     0x7fff83836fff  com.apple.CFNetwork 454.5 (454.5) <319C7138-2839-DA5E-413A-618248BD4A32> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CFNetwork.framework/Versions/A/CFNetwork
    0x7fff8419b000 -     0x7fff841d6ff7  com.apple.AE 496.1 (496.1) <27D2D2E9-B309-7E65-8C3F-7FF01148F0DE> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/AE.framework/Versions/A/AE
    0x7fff842ec000 -     0x7fff842ecff7  com.apple.CoreServices 44 (44) <210A4C56-BECB-E3E4-B6EE-7EC53E02265D> /System/Library/Frameworks/CoreServices.framework/Versions/A/CoreServices
    0x7fff84a8e000 -     0x7fff84b44fff  libobjc.A.dylib ??? (???) <F206BE6D-8777-AE6C-B367-7BEA76C14241> /usr/lib/libobjc.A.dylib
    0x7fff84c39000 -     0x7fff84cd9fff  com.apple.LaunchServices 362 (362) <CCBFC037-7162-E392-B11F-90098891AE20> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/LaunchServices
    0x7fff84cfb000 -     0x7fff84eb9ff7  libSystem.B.dylib ??? (???) <526DD3E5-2A8B-4512-ED97-01B832369959> /usr/lib/libSystem.B.dylib
    0x7fff850c0000 -     0x7fff8516ffff  edu.mit.Kerberos 6.5.9 (6.5.9) <42364D54-C647-14DE-2B1C-D94DAA03F092> /System/Library/Frameworks/Kerberos.framework/Versions/A/Kerberos
    0x7fff85170000 -     0x7fff8522cff7  com.apple.CoreServices.OSServices 352 (352) <CD933BBD-B260-552F-E64E-291D6ED3091A> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/OSServices.framework/Versions/A/OSServices
    0x7fff853b3000 -     0x7fff853fffff  libauto.dylib ??? (???) <072804DF-36AD-2DBE-7EF8-639CFB79077F> /usr/lib/libauto.dylib
    0x7fff85400000 -     0x7fff85406ff7  com.apple.DiskArbitration 2.3 (2.3) <857F6E43-1EF4-7D53-351B-10DE0A8F992A> /System/Library/Frameworks/DiskArbitration.framework/Versions/A/DiskArbitration
    0x7fff857e8000 -     0x7fff85b1afef  com.apple.CoreServices.CarbonCore 861.2 (861.2) <39F3B259-AC2A-792B-ECFE-4F3E72F2D1A5> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CarbonCore.framework/Versions/A/CarbonCore
    0x7fff8717b000 -     0x7fff87292fef  libxml2.2.dylib ??? (???) <EE067D7E-15B3-F043-6FBD-10BA31FE76C7> /usr/lib/libxml2.2.dylib
    0x7fff87a14000 -     0x7fff87a3fff7  libxslt.1.dylib ??? (???) <87A0B228-B24A-C426-C3FB-B40D7258DD49> /usr/lib/libxslt.1.dylib
    0x7fff88806000 -     0x7fff88979ff7  com.apple.CoreFoundation 6.6.1 (550.13) <1E952BD9-37C6-16BE-B2F0-CD92A6283D37> /System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation
    0x7fff889bf000 -     0x7fff88a09ff7  com.apple.Metadata 10.6.2 (507.4) <A28A5E0C-DCDC-A5CE-4EB7-39752E63956A> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/Metadata.framework/Versions/A/Metadata
    0x7fff88a7a000 -     0x7fff88a88ff7  libkxld.dylib ??? (???) <568C35E7-B101-3F1E-0361-3E1E9F15C90B> /usr/lib/system/libkxld.dylib
    0x7fffffe00000 -     0x7fffffe01fff  libSystem.B.dylib ??? (???) <526DD3E5-2A8B-4512-ED97-01B832369959> /usr/lib/libSystem.B.dylib

Model: MacBook2,1, BootROM MB21.00A5.B07, 2 processors, Intel Core 2 Duo, 1.83 GHz, 2 GB, SMC 1.13f3
Graphics: Intel GMA 950, GMA 950, Built-In, spdisplays_integrated_vram
Memory Module: global_name
AirPort: spairport_wireless_card_type_airport_extreme (0x168C, 0x87), Atheros 5416: 2.0.19.4
Bluetooth: Version 2.2.4f3, 2 service, 0 devices, 1 incoming serial ports
Network Service: AirPort, AirPort, en1
Serial ATA Device: TOSHIBA MK6034GSX, 55,89 GB
Parallel ATA Device: MATSHITACD-RW  CW-8221
USB Device: Built-in iSight, 0x05ac  (Apple Inc.), 0x8501, 0xfd400000
USB Device: Apple Internal Keyboard / Trackpad, 0x05ac  (Apple Inc.), 0x021b, 0x1d200000
USB Device: IR Receiver, 0x05ac  (Apple Inc.), 0x8240, 0x5d200000
USB Device: Bluetooth USB Host Controller, 0x05ac  (Apple Inc.), 0x8205, 0x7d100000

comment:27 Changed 11 years ago by ryandesign (Ryan Schmidt)

In your crash log I'm suspicious of the use of system versions of libxml2, libxslt, zlib, and sqlite3, where I would have expected to see MacPorts versions of these being used.

We had a problem with programs crashing before when trying to use both the system's and MacPorts's libxml2. We (thought we) fixed that by rebuilding libxml2 with a two-level namespace. Maybe it's a recurrence of this problem, or maybe a similar problem with one of the other libraries.

comment:28 Changed 11 years ago by royliu@…

Cc: royliu@… added

Cc Me!

comment:29 Changed 11 years ago by lyle@…

Cc: lyle@… added

Cc Me!

comment:30 Changed 11 years ago by lyle@…

I can also reproduce the bug, using the same configuration as previous poster(s). Will be glad to post a crash log if that's useful. Like kena, mine does seem to be referencing the /usr/lib versions of libxml2, libxslt, etc. if that's significant.

comment:31 Changed 11 years ago by gwynne@…

This is an upstream bug in, of all things, APR 1.3.9. Some heavy GDBing revealed that apr_psprintf() doesn't parse the %lld specifier format correctly, which causes it not to advance the va_list correctly, which causes it to crash in strlen() when it tries to handle the %s format, because it's accessing the wrong pointer. The use of the %lld specifier is also in APR (defined by APR_OFF_T_FMT on Darwin), making it an internal inconsistency. Ironically, this appears to be caused by this bit in APR's configure.in, new in APR 1.3.9:

    # Per OS tuning...
    case $host in
    *apple-darwin10.*)
        # off_t is a long long, but long == long long
        if test "$ac_cv_sizeof_long" = "$ac_cv_sizeof_long_long"; then
            off_t_fmt='#define APR_OFF_T_FMT "lld"'
        fi
        ;;
    esac

This check appears to be fallacious. I've attached the obvious patch to solve the issue (against APR version 1.3.9), and I've opened an upstream bug against APR.

Changed 11 years ago by gwynne@…

Attachment: configure.patch added

Quick patch to make things work again.

comment:32 Changed 11 years ago by gwynne@…

Cc: gwynne@… added

Cc Me!

comment:33 in reply to:  31 Changed 11 years ago by danielluke (Daniel J. Luke)

Replying to gwynne@…:

Ironically, this appears to be caused by this bit in APR's configure.in, new in APR 1.3.9:

That's pretty crazy, I think there was even some discussion on the apr mailing list where they had decided that that was the 'best' way to check for that.

This check appears to be fallacious. I've attached the obvious patch to solve the issue (against APR version 1.3.9), and I've opened an upstream bug against APR.

Can you provide a link to the bug here so I can track it?

I'll get to work testing apr and subversion with your patch and hopefully it will fix the issues people are seeing.

Thanks again!

comment:34 Changed 11 years ago by gwynne@…

Opened on Apache's bugzilla as APR bug #48476 - apr_psprintf() does not parse the ll or hh size specifiers. Let me know if I can do anything more to help.

comment:35 Changed 11 years ago by danielluke (Daniel J. Luke)

Resolution: fixed
Status: assignedclosed

Committed in r62330

I will watch the upstream bug and attempt to incorporate any upstream changes/fixes.

Note: See TracTickets for help on using tickets.